#NoTrayIcon
#include <GUIConstantsEx.au3>
#include <Constants.au3>
#include <GuiListView.au3>
#include <GuiImageList.au3>
#include <WindowsConstants.au3>
#include <Misc.au3>
#include <SafeRemoveDrive.dll.au3>
;

;============# Prevent from secondary run #====================================
If _Singleton("  ", 1) = 0 Then
	$hWnd = WinGetHandle("[CLASS:AutoIt v3 GUI;TITLE:  ]")
	
	WinSetState($hWnd, "", @SW_RESTORE)
	WinActivate($hWnd)
	
	Exit
EndIf
;================================================================================

Opt('MustDeclareVars', 1)

Global $hListView, $nDriveEject_Button, $hGUI, $DLL_PATH
Global $nShowApp_TrayItem, $nExitApp_TrayItem, $nLast_DriveTrayItem = -1

Global Const $WM_DEVICECHANGE = 0x0219

Global Const $DBT_DEVICEARRIVAL = 0x8000
Global Const $DBT_DEVICEREMOVECOMPLETE = 0x8004
Global Const $DBT_DEVTYP_VOLUME = 0x00000002

$DLL_PATH = Dll_Expand() ;  

If @error Then
	MsgBox(48, "", "  ." & @CRLF & @CRLF & "OK ===> EXIT")
	Exit
EndIf

CreateTrayItems()
CreateGUI()

Func CreateGUI()
	$hGUI = GUICreate("  ", 470, 235, -1, -1, _
		BitOr($GUI_SS_DEFAULT_GUI, $WS_SIZEBOX), $WS_EX_CLIENTEDGE)
	; ************************************ ; Icon
	GUISetIcon(@ScriptDir & "\Icon.ico")
	; ************************************ ; ListView
	$hListView = GUICtrlCreateListView("|| || ", 10, 10, 450, 180, -1, _
		BitOR($WS_EX_DLGMODALFRAME, $WS_EX_CLIENTEDGE))
	_GUICtrlListView_SetExtendedListViewStyle($hListView, BitOR($LVS_EX_SUBITEMIMAGES, $LVS_EX_GRIDLINES))
	_GUICtrlListView_SetColumnWidth($hListView, 0, 150)
	_GUICtrlListView_SetColumnWidth($hListView, 1, 80)
	_GUICtrlListView_SetColumnWidth($hListView, 2, 70)
	_GUICtrlListView_SetColumnWidth($hListView, 3, 70)
	_GUICtrlListView_SetColumnWidth($hListView, 4, 70)
	GUICtrlSetResizing($hListView, BitOR($GUI_DOCKLEFT, $GUI_DOCKRIGHT, $GUI_DOCKTOP, $GUI_DOCKBOTTOM))
	; ************************************ ; Button
	$nDriveEject_Button = GUICtrlCreateButton("", 10, 200)
	GUICtrlSetResizing($nDriveEject_Button, BitOR($GUI_DOCKSIZE, $GUI_DOCKBOTTOM))
	; ************************************
	GUIRegisterMsg($WM_DEVICECHANGE, "WM_DEVICECHANGE")
	GUIRegisterMsg($WM_GETMINMAXINFO, "WM_GETMINMAXINFO")
	; ************************************
	GUISetState()
	; ************************************
	Local $hImage = _GUIImageList_Create(16, 16, 5, 3)
	_GUIImageList_AddIcon($hImage, @SystemDir & "\shell32.dll", -8)
	_GUICtrlListView_SetImageList($hListView, $hImage, 1)
	; ************************************
	ListView_Fill("REMOVABLE")
	; ************************************
	While 1
		Switch GUIGetMsg()
			Case $GUI_EVENT_CLOSE
				ExitLoop
			Case $GUI_EVENT_MINIMIZE
				GUISetState(@SW_HIDE)
				TraySetState(1)
				TraySetIcon(@ScriptDir & "\Icon.ico")
			Case $nDriveEject_Button
				Local $sSel_Index = _GUICtrlListView_GetSelectedIndices($hListView, 0)
				Local $iSel_Index = Number($sSel_Index)
				Local $sSel_Drive = _GUICtrlListView_GetItemText($hListView, $iSel_Index, 0)
				
				If $sSel_Index = "" Then
					MsgBox(48, "!", "   .", 0, $hGUI)
				Else
					EjectDrive($sSel_Drive)
				EndIf
		EndSwitch
	WEnd
	
	GUIDelete()
EndFunc

Func CreateTrayItems()
	Opt("TrayMenuMode", 1)
	Opt("TrayOnEventMode", 1)
	
	TraySetClick(16)
	TraySetOnEvent($TRAY_EVENT_PRIMARYUP, "Tray_Events")
	
	$nShowApp_TrayItem = TrayCreateItem("   ")
	TrayItemSetState($nShowApp_TrayItem, $TRAY_DEFAULT)
	TrayItemSetOnEvent($nShowApp_TrayItem, "Tray_Events")
	
	TrayCreateItem("")
	
	$nExitApp_TrayItem = TrayCreateItem("  ")
	TrayItemSetOnEvent($nExitApp_TrayItem, "Tray_Events")
EndFunc

Func Tray_Events()
	Switch @TRAY_ID
		Case $TRAY_EVENT_PRIMARYUP, $nShowApp_TrayItem
			GUISetState(@SW_SHOW)
			GUISetState(@SW_RESTORE)
			TraySetState(2)
		Case $nExitApp_TrayItem
			Exit
		Case Else
			Local $sTrayItemText = TrayItemGetText(@TRAY_ID)
			Local $sDrive_Name = StringTrimRight(StringTrimLeft($sTrayItemText, StringInStr($sTrayItemText, "(")-1), 3)
			
			Local $iAsk = MsgBox(52, "!", "   [" & $sDrive_Name & "], ?", 0, $hGUI)
			If $iAsk = 6 Then EjectDrive($sDrive_Name)
	EndSwitch
EndFunc

Func EjectDrive($sDrive)
	Local $strDriveLabel = StringMid($sDrive, 2, 1)
	Local $tblDllResult = DllCall($DLL_PATH, "str", "SafeRemoveDrive", "str", $strDriveLabel)
	
	If Int($tblDllResult[0]) = 0 Then
		MsgBox(48, "", "    .", 0, $hGUI)
	Else
		MsgBox(64, "", " [" & $sDrive & "]  .", 0, $hGUI)
	EndIf
EndFunc

Func _String_GetDisplaySize($iByteSize, $iRound = 2)
	Local $asBytes[5] = [4, ' ', ' ', ' ', ' ']
	Local $iBytes_Val = 2 ^ 10
	If $iByteSize < $iBytes_Val Then Return $iByteSize & ' '
	
	For $i = 4 To 1 Step -1
		If $iByteSize >= $iBytes_Val ^ $i Then _
			Return StringReplace(Round($iByteSize / $iBytes_Val ^ $i, $iRound) & $asBytes[$i], ".", ",")
	Next
EndFunc

Func Dll_Expand($strOutDLLName = "")
	Local $hFileDllOut
	
	If IsKeyword($strOutDLLName) Or $strOutDLLName = "" Or $strOutDLLName = -1 Then $strOutDLLName = "SafeRemoveDrive.dll"
	
	If Not FileExists(@TempDir & "\" & $strOutDLLName) Then
		$hFileDllOut = FileOpen(@TempDir & "\" & $strOutDLLName, 2)
		If $hFileDllOut = -1 Then Return SetError(1)
	EndIf
	
	FileWrite($hFileDllOut, Call("SafeRemoveDrive"))
	FileClose($hFileDllOut)
	
	Return @TempDir & "\" & $strOutDLLName
EndFunc

Func WM_DEVICECHANGE($hWnd, $Msg, $wParam, $lParam)
	If $wParam = $DBT_DEVICEARRIVAL Or $wParam = $DBT_DEVICEREMOVECOMPLETE Then
		Local $DEV_BROADCAST_VOLUME = DllStructCreate("int dbcvsize;int dbcvdevicetype;int dbcvreserved;int dbcvunitmask;" & _
			"ushort dbcvflags", $lParam)
		Local $iDriveType = DllStructGetData($DEV_BROADCAST_VOLUME, "dbcvdevicetype")
	Else
		Return $GUI_RUNDEFMSG
	EndIf
	
	If $iDriveType <> $DBT_DEVTYP_VOLUME Then Return $GUI_RUNDEFMSG
	
	Switch $wParam
		Case $DBT_DEVICEARRIVAL, $DBT_DEVICEREMOVECOMPLETE
			ListView_Fill("REMOVABLE")
	EndSwitch
	
	Return $GUI_RUNDEFMSG
EndFunc

Func WM_GETMINMAXINFO($hWnd, $Msg, $wParam, $lParam)
	Local $MINGuiX = 480
	Local $MINGuiY = 240
	Local $MAXGuiX = 1000
	Local $MAXGuiY = 600
	
	Local $MinMaxInfo = DllStructCreate("int;int;int;int;int;int;int;int;int;int", $lParam)
	
	DllStructSetData($MinMaxInfo, 7, $MINGuiX) ; min X
	DllStructSetData($MinMaxInfo, 8, $MINGuiY) ; min Y
	DllStructSetData($MinMaxInfo, 9, $MAXGuiX) ; max X
	DllStructSetData($MinMaxInfo, 10, $MAXGuiY) ; max Y
	
	Return $GUI_RUNDEFMSG
EndFunc

Func IsFloppy($strDriveLetter)
	Local $tblResult = DllCall("kernel32.dll", "dword", "QueryDosDevice", "str", $strDriveLetter, "str", "", "dword", 260)
	If Not $tblResult[0] Then Return SetError(1)
	
	Local $strDosDeviceName = $tblResult[2]
	
	If StringInStr($strDosDeviceName, "\floppy") <> 0 Then Return True
	Return False
EndFunc

Func ListView_Fill($cType)
	Local $tblDrives, $bIsFloppy, $iDrives_Count = 0
	
	_GUICtrlListView_DeleteAllItems(GUICtrlGetHandle($hListView))
	
	For $i = $nExitApp_TrayItem + 1 To $nLast_DriveTrayItem
		TrayItemDelete($i)
	Next
	
	$tblDrives = DriveGetDrive($cType)
	
	If Not @error Then
		For $i = 1 To $tblDrives[0]
			$bIsFloppy = IsFloppy($tblDrives[$i])
			
			If Not @error Then
				If $bIsFloppy = True Or DriveStatus($tblDrives[$i]) <> "READY" Then ContinueLoop
				
				Local $strLabel = DriveGetLabel($tblDrives[$i])
				If $strLabel = "" Then $strLabel = " "
				
				Local $nSpaceTotal = DriveSpaceTotal($tblDrives[$i])
				Local $nSpaceFree = DriveSpaceFree($tblDrives[$i])
				Local $strFS = DriveGetFileSystem($tblDrives[$i])
				Local $strTmp = $tblDrives[$i]
				
				Local $nItem = _GUICtrlListView_AddItem($hListView, "(" & StringUpper($tblDrives[$i]) & ") " & $strLabel, 0)
				_GUICtrlListView_AddSubItem($hListView, $nItem, " ", 1)
				_GUICtrlListView_AddSubItem($hListView, $nItem, _String_GetDisplaySize($nSpaceTotal * 1024 ^ 2), 2)
				_GUICtrlListView_AddSubItem($hListView, $nItem, _String_GetDisplaySize($nSpaceFree * 1024 ^ 2), 3)
				_GUICtrlListView_AddSubItem($hListView, $nItem, $strFS, 4)
				
				$iDrives_Count += 1
				If $iDrives_Count = 1 Then TrayCreateItem("", -1, 0)
				
				$nLast_DriveTrayItem = TrayCreateItem(" (" & StringUpper($tblDrives[$i]) & ") " & $strLabel & "...", -1, 0)
				TrayItemSetOnEvent($nLast_DriveTrayItem, "Tray_Events")
			EndIf
		Next
	EndIf
EndFunc
